#!/usr/bin/perl

use strict;
use warnings;
use List::Util qw(sum);
use Data::Dumper;

#x: authorities y: hubs
my (@x, @y);

#even dumber xml "parser"...
sub getattr($$){
	my $line = shift;
	my $attr = shift;
	chomp $line;
	$line =~ s#.*$attr="([^"]*)".*#$1#;
	return $line;
}

open my $infile, "<", @ARGV == 0 ? "graph.xml" : $ARGV[0] or die $!;

foreach my $line (<$infile>){
	if($line =~ m#node#){
		my $id = getattr($line, "id");
		my $name = getattr($line, "name");
		$id=~s#n##;
		$x[$id]{name} = $name;
		$x[$id]{weight} = 1;
		$x[$id]{id} = $id;
	}elsif ($line =~ m#edge#){
		my $id = getattr($line, "source");
		$id =~ s#n##;
		my $target = getattr($line, "target");
		$target =~ s#n##;
		push @{$y[$id]{target}}, $target;
		print "Pushing $target into $id\n";
		$y[$id]{weight} = 1;
		$y[$id]{id} = $id;
		$y[$id]{name} = $x[$id]{name};
	}
}
close $infile;
#handle undefined hubs...
for(my $i=0; $i<@x; $i++){
	next if defined($y[$i]);
	$y[$i]{weight} = 1;
	$y[$i]{id} = $i;
	$y[$i]{name} = $x[$i]{name};
}
print Dumper @x;
print Dumper @y;

###start algo
foreach(1..100){ # number of iterations: 100
	for (my $i=0; $i<@x; $i++){
		my $tmp = 0;
		for (my $j=0; $j<@y; $j++){
			if (grep /^$i$/, @{$y[$j]{target}}){
				$tmp += $y[$j]{weight};
			}
		}
		$x[$i]{weight} = $tmp;
	}

	for (my $i=0; $i < @y; $i++){
		my $tmp=0;
		foreach(@{$y[$i]{target}}){
			$tmp += $x[$_]{weight};
		}
		$y[$i]{weight} = $tmp;
	}
#some perl magic...
	my $sum = sqrt(sum(0, map{$_->{weight}**2}@x));
	foreach(@x){ $_->{weight} /= $sum; }
	$sum = sqrt(sum(0, map{$_->{weight}**2}@y));
	foreach(@y){ $_->{weight} /= $sum; }
}
###end algo

#sort the results and do some formatting
@x = sort {$b->{weight} <=> $a->{weight}} @x;
@y = sort {$b->{weight} <=> $a->{weight}} @y;
foreach my $xs(@x){
format X =
	@<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<| @<<<<<<<<<<<<<<<<<<<<
	"Auth:" , $xs->{name}, $xs->{weight} 
.
	$~ = 'X';
	write();
}
print "\n";

foreach my $ys(@y){
format Y=
	@<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<| @<<<<| @<<<<<<<<<<<<<<<<<<<<
	"Hub:", $ys->{name}, $ys->{id}, $ys->{weight} 
.
	$~ = 'Y';
	write();
}
